/* Testprogram fr BIN_IO Module
   Axel Rohrbacher
   18.04.2010

   Erlaubt die Versendung von Kommandos ber Serielle Schnittstelle vom PC.
   Diese werden dann ber TWI an die BIN_IO_Module weitergegeben.

   Include directories setzen !
   F_CPU setzen !

*/

// AVR includes
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Lib includes
#include "uart.h"
#include "watchdog.h"
#include "TWI_Slave.h"

// Programm includes
#include "cmd.h"


int main()
{
    unsigned char s[20]; // Lesbarer Eingangs-String
	unsigned char c[20]; // Binr-Kommandopuffer - Data in i2c.

// Inits
UART_init();
sei();

fdevopen( UART_fputc, UART_fgetc );			// establish buffered I/O callbacks

// AR Watchdog einschalten - wird fr Reset genutzt fr Bootloader
wdt_enable(WDTO_500MS);
printf_P(PSTR("Testprogramm Out Module \r\n"));

/*
** Start TWI Slave with address 50 and bitrate of 100000 Hz
*/
	TWIS_Init (50, 100000);

for (;;) {

	wdt_reset();
	
	/* Interpretiere das Testkommando und speichere Protokollcode in c */
	CMD_interpreter(c,s);
	
	//UART_readline();
	//TWI_writeline();
	//TWI_readslave();
	//UART_writeline();
	};

return(0);

}
