
#include <avr/pgmspace.h>
#include <util/delay.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "cmd.h"
#include "watchdog.h"
#include "TWI_Slave.h"

/* Protokoll Struktur*/
struct command_struct cmd;


/* Command-interpreter - translates simple numbers into a test-command */
void CMD_interpreter(unsigned char * data, unsigned char *cmd_string)
{
uint8_t i;

/* Read frame from master */
i=get_frame_from_master(&cmd, data);


}

/*
** Read frame from the master
*/
uint8_t get_frame_from_master(struct command_struct * c, uint8_t * data)
{
uint16_t i;
uint8_t	TWIS_ResonseType;

/* Put data bytes into c */
c->p_data=data;

/*
** Check wether something is to do for the TWI slave interface
*/
if (TWIS_ResonseRequired (&TWIS_ResonseType))
	{
	switch (TWIS_ResonseType)
		{
/*
** Slave is requests to read bytes from the master.
*/
		case TWIS_ReadBytes:
			c->to_address_module=TWIS_ReadAck (); 	// Binary-Out-Module
			c->to_address_object=TWIS_ReadAck ();   	// Address-Object 0 = Port A, PIN 0
			c->from_address_module=TWIS_ReadAck (); // Net-IO-Master
			c->from_address_object=TWIS_ReadAck ();	// Object 0 = der NET-IO-Master selbst

			// 16bit 
			c->count_data_bytes=TWIS_ReadAck ();		// 1 Byte
			c->count_data_bytes=(c->count_data_bytes<<8);
			c->count_data_bytes |=TWIS_ReadAck ();

			for (i=0;i<c->count_data_bytes;i++)
				{
				c->p_data[i]=TWIS_ReadAck ();				// p_data = char string c.
				}
			//16 bit
			c->checksum=TWIS_ReadAck ();				// Dummy checksum 			
			c->checksum=(c->checksum<<8);
			c->checksum|=TWIS_ReadNack ();
			
			TWIS_Stop ();
			debug_print_cmd(c);
			break;
		}
	return TWIS_ResonseType; 
	}
else 
	{
	return 0;
	}
}


void debug_print_cmd(struct command_struct * c)
{
uint16_t i;

printf_P(PSTR("to_address_module %d\r\n"), c->to_address_module);
printf_P(PSTR("to_address_object %d\r\n"), c->to_address_object);
printf_P(PSTR("from_address_module %d\r\n"), c->from_address_module);
printf_P(PSTR("from_address_object %d\r\n"), c->from_address_object);
printf_P(PSTR("count_data_bytes %d\r\n"), c->count_data_bytes);
for (i=0;i<c->count_data_bytes;i++)
	{
	printf_P(PSTR("p_data Nr. %d ist: %d\r\n"), i, (int)c->p_data[i]);				// p_data = char string c.
	} 
printf_P(PSTR("checksum %d\r\n"), c->checksum);
}
