
#include <avr/pgmspace.h>
#include <util/delay.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "cmd.h"
#include "../libs/WATCHDOG/watchdog.h"
#include "../libs/TWI/TWI_Master.h"

/* Protokoll Struktur*/
struct command_struct cmd;


/* Command-interpreter - translates simple numbers into a test-command */
void CMD_interpreter(unsigned char * c, unsigned char *s)
{
int i;

i=atoi(s);
//printf_P(PSTR("Komanndozahl ist: %d\r\n"), i);

cmd.to_address_module=50; // Binary-Out-Module
cmd.to_address_object=0;   // Address-Object 0 = Port A, PIN 0
cmd.from_address_module=10; // Net-IO-Master
cmd.from_address_object=0;	// Object 0 = der NET-IO-Master selbst
cmd.count_data_bytes=1;		// 1 Byte
cmd.p_data=c;				// p_data = char string c.
cmd.checksum=9;				// Dummy checksum 

switch (i) {
	case 0:
		break;
	case 1:
		printf_P(PSTR("50/0/ein\r\n"));
		c[0]=1;
		send_frame_to_slave(&cmd);
		break;
	case 2:
		printf_P(PSTR("50/0/aus\r\n"));
		c[0]=0;
		send_frame_to_slave(&cmd);
		break;
	case 9:
		boot_load();
		break;
	}
}

/*
** Read frame from the slave.

uint8_t get_frame_from_slave(struct command_struct * c)
{
uint16_t i;


   	if (!TWIM_Start (cmd.to_address_module, TWIM_READ))
		{
		TWIM_Stop ();
		printf ("Could not start TWI Bus for READ\n");
    	}
	else
		{
		for (i=0;i<7;i++)
			{
        	Data[i] = TWIM_ReadAck ();
			printf ("Reading Byte %d: %d\n", i, Data[i]);
			}
       	Data[7] = TWIM_ReadNack ();
		printf ("Reading Byte %d: %d\n", i, Data[7]);
		TWIM_Stop ();
		_delay_ms (1000);
		}
}
*/

/*
** Write frame to the slave.
*/
uint8_t send_frame_to_slave(struct command_struct *c)
{
uint16_t i=0;

   	if (!TWIM_Start (cmd.to_address_module, TWIM_WRITE))
		{
		TWIM_Stop ();
		printf ("Could not start TWI Bus for WRITE\r\n");
		return 0;
    	}
	else
		{
		TWIM_Write(cmd.to_address_module);
		TWIM_Write(cmd.to_address_object);
		TWIM_Write(cmd.from_address_module);
		TWIM_Write(cmd.from_address_object);
		TWIM_Write( (uint8_t) (cmd.count_data_bytes>>8));
		TWIM_Write( (uint8_t) (cmd.count_data_bytes)   );
		for (i=0;i<cmd.count_data_bytes;i++)
			{
        	TWIM_Write (cmd.p_data[i]);
			printf ("Byte %d sent: %d\n", i, cmd.p_data[i]);
			}
		TWIM_Write( (uint8_t) (cmd.checksum>>8) );
		TWIM_Write( (uint8_t) (cmd.checksum) 	);


		TWIM_Stop ();
		}
return 1;
}
 
