/*
 *
 * (c) by Alexander Neumann <alexander@bumpern.de>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License (either version 2 or
 * version 3) as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * For more information on the GPL, please go to:
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef _FS20_CONFIG_H
#define _FS20_CONFIG_H

#include <avr/version.h>
#include <avr/io.h>

/* check for avr-libc version */
#if __AVR_LIBC_VERSION__ < 10404UL
#error "newer libc version (>= 1.4.4) needed!"
#endif

/* check if cpu speed is defined */
#ifndef F_CPU
#error "please define F_CPU!"
#endif

#define FS20_SUPPORT
#define FS20_RECEIVE_SUPPORT
#define FS20_RECEIVE_WS300_SUPPORT
#define DEBUG_FS20_REC
#define DEBUG_FS20_REC_QUEUE
#define DEBUG_FS20_REC_VERBOSE
#define DEBUG_FS20_WS300
//#define FS20_RECV_PROFILE

//Baudrate der seriellen Schnittstelle
//#define BAUDRATE 57600

/* global version defines */
#define VERSION_STRING "0.2"


  /* fs20 support */
  /*  pin(FS20_SEND, PB2) */

  /* DO NOT CHANGE PIN!  USES INTERNAL COMPARATOR! */
  /*pin(FS20_RECV, PB3)*/



#endif /* _CONFIG_H */
