// PWM zur Ansteuerung der Relais mit geringerer Power
// Einstellungen in config.h

#include <avr\io.h>
#include "config.h"
#include "usart.h"

#ifndef FS_20
void pwm_init(void)
{

// AR OC2A = PD7 (auf Ext. Pin 6)
DDRD |= (1<< PD7 );

// Timer initialisieren
TCNT2 = 0;

// Output Compare Register auf brauchbaren Wert setzen
// Erstmal auf 0xFF, d.h. full power
OCR2A=0xff;

// Start timer OC2 nicht invertiert, PWM Fast, Prescaler 1024
TCCR2A = (1 << COM2A1) | ( 1<<WGM21 ) |( 1<<WGM20 ) ;
TCCR2B = ( 1<<CS22 ) |( 1<<CS21 ) | (1<<CS20);
}

void pwm_set(uint8_t wert)
{
OCR2A=wert;
usart_write("pwm_set %1i \r\n",OCR2A); 
}
#endif 


