/*----------------------------------------------------------------------------
 Axel Rohrbacher
 siehe Kommentare in Main fr Credits
------------------------------------------------------------------------------*/

#include "timer.h"


volatile unsigned long time;
volatile unsigned long time_watchdog = 0;



//----------------------------------------------------------------------------
//Diese Routine startet und inizialisiert den Timer
void timer_init (void)
{

		#if defined (__AVR_ATmega644__)
			//Asynchroner Modus ein, Oszillator an TOSC1 und TOSC2 aktiv
			ASSR |= (1<<AS2);
			TCCR2B = 0x05;
			while(ASSR & 0x11);
			//Capture/Compare-Interrupt aktiv
			TIMSK2 |= (1<<OCIE2A);
		#else
			//Asynchroner Modus ein, Oszillator an TOSC1 und TOSC2 aktiv
			ASSR  = (1<<AS2);
			//CTC-Modus an (Clear Timer on Compare Match)
			TCCR2 = (1<<WGM21);			
			//dieser Wert ergibt eine Sekunde Periodendauer
			OCR2  = 31;	
			//lsche Prescaler 2				
			SFIE  = (1<<PSR2);			
			//Starte Timer 2 mit Prescaler gleich 1/1024
			TCCR2 |= (1<<CS22)|(1<<CS21)|(1<<CS20); 
			while(ASSR & 0x07);
			//Capture/Compare-Interrupt aktiv
			TIMSK = (1<<OCIE2);
		#endif

			// AR Timer 2 -----------------------------------------------------
			// Timer initialisieren
			TCNT2 = 0;


			// Start timer OC1 nicht invertiert, 
			// CTC=clear timer on compare match, 
			// Prescaler 1024
			TCCR2A = (1 << COM2A1) | ( 1<<WGM21 ) ;
		    TCCR2B = ( 1<<CS22 ) | (1<<CS20);
			// AR Interupt auslsen
			TIMSK2 |= (1 << OCIE2A);

	#endif
return;
};

//----------------------------------------------------------------------------
//Timer Interrupt
#if EXTCLOCK==1
	#if defined (__AVR_ATmega644__)
		ISR (TIMER2_COMPA_vect){
	#else
		ISR (TIMER2_COMP_vect){
	#endif
#else
	
	// Version mit Timer 1 - alle 1sek
	//ISR (TIMER1_COMPA_vect){

	// Version mit Timer 0 
	// Alle F_CPU/1024/252
	//ISR (TIMER0_COMPA_vect) {

	// Version mit Timer 2
	// Alle F_CPU/1024/252
	#ifndef FS_20
		ISR (TIMER2_COMPA_vect)   {
	#else
		// Version Timer 2 FS20
		ISR (TIMER2_COMPA_vect)     {
	#endif 
#endif

	// AR Version mit timer 0 oder 2
	i++;
	
	// Alle 1 sek 
#ifndef FS_20
	if (i > 62) 
#else
	if (i > 488)

#endif 
	{
	i=0;


	//Sekunde um 1 erhhen
	time++;
    if((time_watchdog++) > WTT)
        {
        time_watchdog = 0;
        stack_init(); 
        }
    eth.timer = 1;
	#if USE_NTP
	ntp_timer--;
	#endif //USE_NTP


	} // end if (i > 62);


}
