// AR das braucht es, da der Watchdog auch nach Reset aktiv ist - dann resetted 
// er immer wieder nach dem Bootload Prozess. Die folgenden Funktionen schalten
// das ab - siehe FAQ in der AVRLIB
// Function Pototype

#include <avr/interrupt.h>
#include "watchdog.h"
volatile int i;

void wdt_init(void) __attribute__((naked)) __attribute__((section(".init3")));


// Function Implementation
void wdt_init(void) 
{
    MCUSR = 0;
    wdt_disable();

    return;
}


// jump to bootloader
void boot_load(void)
{
  char temp;

  cli();                        // Disable all interrupts

  // changing interrupt vector to bootloader section
  // only needed if BOOTRST is not used
  temp = MCUCR;                 // Get MCUCR
  MCUCR = temp | (1<<IVCE);     // Enable change of Interrupt Vectors
  MCUCR = temp | (1<<IVSEL);    // Move interrupts to Boot Flash section

  // enable watchdog and release it
  do {
    wdt_enable(WDTO_15MS);
    for(;;){}
  } while(0);
}
